<?php
// *******************************************************
function DeletePost ()
{
	echo ('<form name="DelPost" action="index.php" method="POST">');
	echo ('<input type="hidden" name="DelPost" value="delpost">');
	echo ('</form>');
	echo ('<script type="text/javascript">document.DelPost.submit();</script>');
}

// *******************************************************
function SaveData ($DataFile, $Data)
{
	global $DataDir;

	if (!$fp = fopen ($DataDir.'/'.$DataFile, 'w'))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t write to the file: ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else
	{
		fwrite ($fp, serialize($Data));
		fclose ($fp);
		DeletePost ();
	}
}

// *******************************************************
function LoadData ($DataFile)
{
	global $DataDir;

	if (!$fp = fopen ($DataDir.'/'.$DataFile, "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file: ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else
	{
		$Data = unserialize (fgets ($fp));
		fclose ($fp);
		return ($Data);
	}
}

// *******************************************************
function ImportData ()
{
	global $Include;
	global $Exclude;

	$File1Valid1 = false;
	$File1Valid2 = false;
	$File2Valid = false;
	
	$Temp = "";
	$Value = array ();
	$Itemname = "";
	$Desc = $_POST["FileDesc"];
	$Data = array ();
	
	$CrewToClassVar = false;

	// Datei öffnen
	if (!$fp = fopen ($_FILES["ItemData"]["tmp_name"], "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else if (!$fp2 = fopen ($_FILES["ItemNames"]["tmp_name"], "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	
	// Item-Daten per Zeile einlesen
	for ($i=0; !feof ($fp); $i++)
	{
		$Temp = fgets ($fp);
		
		if (strpos ($Temp, "void InitItems()") !== false)
			$File1Valid2 = true;
		
		if ($File1Valid2 === true && strpos ($Temp, "WEAPONS"))
			$File1Valid1 = true;
		
		if ($File1Valid1)
		{
			$Value = DecodeLine ($Temp);			

			// Value[1] = Type  (price)
			// Value[2] = Value (500)
			if ($Value !== false && substr ($Temp, 0, 2) != "//")	// Daten keine Bemerkung!
			{
				$Value[1] = strtolower ($Value[1]);
				
				if ($Value[1] == "groupid")
				{
					$Group = explode ('_', $Value[2], 2);
				}
				else if ($Value[1] == "name")
				{
					$Itemname = $Value[2];
					$Data[$Itemname] = array ();
					$Data[$Itemname]["groupID"] = $Group[0];
				}
				else if ($Itemname != "" && in_array ($Value[1], array_keys ($Include)))
				{
					$Data[$Itemname][$Value[1]] = $Value[2];		// $Data["SuperMod"]["Blad1"]["Price"] = 500
				}
			}
		}
	}

	// Datei schließen
	fclose($fp);

	if ($File1Valid1)
	{
		// Item-Namen per Zeile einlesen
		for ($i=0; !feof ($fp2); $i++)
		{
			$Temp = fgets ($fp2);
			
			if (strpos ($Temp, "new_string") !== false)
				$File2Valid = true;
			
			if ($File2Valid)
			{
				$Value = DecodeLine2 ($Temp);
				
				if ($Value !== false && substr ($Temp, 0, 1) != ";")	// Daten keine Bemerkung!
				{
					$Data2[$Value[1]] = $Value[2];			// $Data2["Warship1"] = "Fourth Rate Man 'o War"
				}
			}
		}
		
		fclose($fp2);

		if ($File2Valid)
		{
			foreach ($Data as $Itemname => $ItemData)
			{
				// echten Namen einfügen (wenn verfügbar)
				if (isset ($Data2[$Itemname]))
				{
					$Data[trim ($Data2[$Itemname], '"')] = $ItemData;
					unset ($Data[$Itemname]);
				}
			}
			ksort ($Data);

			// Daten speichern
			SaveData ($Desc, $Data);
		}
		else
		{
			echo ('<script type="text/javascript">alert ("The uploaded names-file is not valid!");</script>');
			DeletePost ();
			exit (-1);
		}
	}
	else
	{
		echo ('<script type="text/javascript">alert ("The uploaded ships-file is not valid!");</script>');
		DeletePost ();
		exit (-1);
	}
}

// *******************************************************
function DecodeLine ($String)
{
	$Ret = preg_match ('/itm\.([^\s]*)[\s]*=[\s]*([\w]+[\.]?[\w]*);/i', $String, $Arr);			// Diverse
	
	if ($Ret == 0)
		$Ret = preg_match ('/itm\.(name)[\s]*=[\s]*"([\w]+)";/i', $String, $Arr);				// Name
	
	if ($Ret == 1)
		return ($Arr);
	else
		return (false);
}

// *******************************************************
function DecodeLine2 ($String)
{
	$Ret = preg_match ("/(itmname_[\w]+)[\s]+{([^}]*)}/i", $String, $Arr);					// Namenzuordnung	
	
	if ($Ret == 1)
		return ($Arr);
	else
		return (false);
}

// *******************************************************
function SortDataBy ($Data, $Sort1, $Sort2="")
{
	$SortBy1 = SORT_ASC;
	$SortBy2 = SORT_ASC;
	
	if ($Sort1[0] == "-")
		$SortBy1 = SORT_DESC;		
	$Sort1 = substr ($Sort1, 1);
	
	if ($Sort2 != "")
	{
		if ($Sort2[0] == "-")
			$SortBy2 = SORT_DESC;
		$Sort2 = substr ($Sort2, 1);
	}

	foreach ($Data as $Key => $Value)
	{
		if ($Sort1 == "Name")
			$temp[$Key] = "";
		else
		{
			if (array_key_exists ($Sort1, $Value))
				$temp[$Key] = $Value[$Sort1];
		}
		
		if ($Sort2 != "")
		{
			if ($Sort2 == "Name")
				$temp2[$Key] = "";
			else
			{
				if (array_key_exists ($Sort2, $Value))
					$temp2[$Key] = $Value[$Sort2];
			}
		}
	}

	if ($Sort2 == "")		// sort by "Sort1" and Name
	{
		if ($Sort1 == "Name")
			array_multisort (array_keys($temp), $SortBy1, $temp);
		else
			array_multisort (array_values($temp), $SortBy1, array_keys($temp), SORT_ASC, $temp);
	}
	else					// sort by "Sort1" and "Sort2" and Name
	{
		if ($Sort1 == "Name")
			array_multisort (array_keys($temp), $SortBy1, array_values($temp2), $SortBy2, $temp);
		else if ($Sort2 == "Name")
			array_multisort (array_values($temp), $SortBy1, array_keys($temp2), $SortBy2, $temp);
		else
			array_multisort (array_values($temp), $SortBy1, array_values($temp2), $SortBy2, array_keys($temp), SORT_ASC, $temp);
	}

	$Data = array_merge ($temp, $Data);
	
	return ($Data);
}

// *******************************************************
function ShowSavedCompare ($ShowArr)
{
	global $Include;
	$Sort = $ShowArr["Sort"];
	$FullData = array ();
	$DataFiles = array ();
	
	for ($i=0; $i<sizeof($ShowArr["F"]); $i++)
	{
		$FullData[$i]["File"] = $ShowArr["F"][$i];
		$FullData[$i]["Name"] = $ShowArr["S"][$i];
		$DataFiles[$ShowArr["F"][$i]] = "";
	}

	$DataFiles = array_keys ($DataFiles);
	
	if ($Sort == "true")
		$FullData = MultiSortByKey ($FullData, "Name");

	foreach ($DataFiles as $File)
	{
		$Data = LoadData ($File);
		
		for ($i=0; $i<sizeof($FullData); $i++)
		{
			// der erste Merge erzeugt ein Array mit allen gewünschten Datenfeldern und füllt die Zellen ohne Inhalt aus
			// der zweite Merge sorgt dafür, dass die vorhanden Daten des FullData nicht überschrieben werden
			if ($FullData[$i]["File"] == $File)
				$FullData[$i] = array_merge ($FullData[$i], array_merge (array_fill_keys (array_keys ($Include), '-'), $Data[$FullData[$i]["Name"]]));
		}
	}
	
	// Header
	echo ('<tr class="header">');
	foreach ($FullData[0] as $Type => $Data)
	{
		if (array_key_exists ($Type, $Include))
			echo ('<td>'.$Include[$Type].'</td>');
		else
			echo ('<td>'.$Type.'</td>');
	}
	echo ('</tr>');
	
	// Data
	for ($i=0; $i<sizeof($FullData); $i++)
	{
		echo ('<tr class="highlight"><td style="text-align:left;">'.$FullData[$i]["File"].'</td><th>'.$FullData[$i]["Name"].'</th>');
		$FullData[$i] = array_slice ($FullData[$i], 2);
		foreach ($FullData[$i] as $Type => $Data)
			echo ('<td onmouseover="Tip(\''.$Include[$Type].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.$Data.'</td>');
		echo ('</tr>');
	}

	// Show overlay
	echo ('<script>document.getElementById("DivCompare").style.display = "initial"; document.getElementById("DivCompare").parentElement.style.overflow="hidden";</script>');
}
?>
