﻿<!DOCTYPE html>

<!--
o Imports items-data from the game "Caribbean Tales" or it's mods
o Table has various display options, can be sorted, filtered and compared

(c) Stumpfl Markus
19.09.2017		Initial Release (copy from "Pirates of the Caribbean" WebApp)


Tooltip: (c) http://www.walterzorn.com
-->

<html lang="en">
<head>
	<title>Corsair 3 - Item Data Extraction Tool</title>
	<meta charset="utf-8">
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<meta http-equiv="Content-Style-Type" content="text/css">
	<link rel="icon" sizes="128x128" type="image/png" href="img/favicon.png">
	<link rel="prefetch" href="img/pageup.png">	
	<link rel="stylesheet" type="text/css" media="screen" href="style.css">
	<script type="text/javascript" src="functions.js"></script>
</head>
<body>
<?php
// Ask if the comparison table should be sorted:
if (!empty($_GET)&& !isset ($_GET["Sort"]))
	echo ('<script>AskToSort ();</script>');
?>

<script type="text/javascript" src="tooltip.js"></script>

<img class="top" alt="TOP" onclick="window.scrollTo(0,0);" src="img/pageup.png" onmouseover="Tip('Scroll to top');" onmouseout="UnTip();" />

<div id="Compare">
	<a href="#" onclick="UnTip(); ShowCompare();" onmouseover="Tip('Compare selected items', ABOVE, true, OPACITY, 100);" onmouseout="UnTip();">COMPARE</a>
</div>

<?php
	$DataDir = 'data';
	
	$Include = array (
				"groupID" => "Group",
				"price" => "Price",
				"dmg_min" => "Min-Dmg",
				"dmg_max" => "Max-Dmg",
				"miss" => "Miss",
				"piercing" => "Piercing",
				"block" => "Blocking",
				"minlevel" => "Min-Level",
				"rare" => "Rarity",
				"uniq" => "Unique",
				"chargeq" => "Shots",
				"chargespeed" => "Reload Speed",
				"accuracy" => "Accuracy",
				"scope.zoom" => "Zoom",
				"scope.time_activate" => "Activation Time",
				"scope.time_update" => "Update Time",
				"scope.show.nation" => "Show Nation",
				"scope.show.cannons" => "Show Cannons",
				"scope.show.ship_name" => "Show Ship Name",
				"scope.show.ship_type" => "Show Ship Type",
				"scope.show.hull" => "Show Hull",
				"scope.show.sail" => "Show Sail",
				"scope.show.crew" => "Show Crew",
				"scope.show.speed" => "Show Speed",
				"scope.show.charge" => "Show Shots",
				"scope.show.captain_skills" => "Show Captain Skills"
				);
	
	$Classes = array (
				"- ALL -",
				"BLADE",
				"GUN",
				"SPYGLASS",
				"SABERGUN"
				);
			
	// PHP-Variable to JS
	echo ('<script>');
		echo ('var Groups = new Array (');
		for ($i=0; $i<sizeof($Classes); $i++)
			echo ('"'.$Classes[$i].'", ');
		echo (');');
		echo ('var Filters = new Array ();');
		echo ('Filters[1] = new Array ("price", "dmg_min", "dmg_max", "miss", "piercing", "block", "minlevel", "rare", "uniq");');
		echo ('Filters[2] = new Array ("price", "dmg_min", "dmg_max", "minlevel", "rare", "uniq", "chargeq", "chargespeed", "accuracy");');
		echo ('Filters[3] = new Array ("price", "scope.zoom", "scope.time_activate", "scope.time_update", "scope.show.nation", "scope.show.cannons", "scope.show.ship_name", "scope.show.ship_type", "scope.show.hull", "scope.show.sail", "scope.show.crew", "scope.show.speed", "scope.show.charge", "scope.show.captain_skills");');
		echo ('Filters[4] = new Array ("price", "dmg_min", "dmg_max", "miss", "accuracy", "piercing", "block", "minlevel", "rare", "uniq");');
	echo ('</script>');
	
	$ColumnsToDisplay = false;
	
	require_once ('functions.php');
	
// *********************************************************************************
	
// Delete selected Datafile
	if (isset ($_POST["SelectObjectsChoice"]) && $_POST["SelectObjectsChoice"] == "delete")
	{
		global $DataDir;

		foreach ($_POST["Objects"] as $File)
		{
			if (!unlink ($DataDir.'/'.$File))
				echo ('<script type="text/javascript">alert ("Couldn\'t delete the file: ('.$File.')!");</script>');
		}

		DeletePost ();
	}
	
// Import New Items-File
	if (isset ($_FILES["ItemData"]["tmp_name"]) && isset ($_FILES["ItemNames"]["tmp_name"]) && isset ($_POST["FileDesc"]))
	{
		ImportData ();
	}

// Check Data Files
	if (is_dir ($DataDir))
	{
		$handle = opendir($DataDir);
		$o = 0;
		while (false !== ($DataFiles[$o] = readdir($handle)))
		{
			if ($DataFiles[$o] != '.' && $DataFiles[$o] != '..')
				$o++;
		}
		closedir($handle);

		$DataFiles = array_slice ($DataFiles, 0, sizeof($DataFiles)-1);
		sort ($DataFiles);
	}
	else
		$DataFiles = array ();

// Load Shipsfile Form
	echo ('<h1>Corsair 3 / Sea Dogs 3 / Age of Pirates / Caribbean Tales</h1>');

	echo ('<abbr onmouseover="Tip(\'<dl><dt>Load Data</dt><dd>locate the #initItems.c# and the #ItemsDescribe.txt# files in the game directory</dd><dd>select them via the Load-Forms</dd><dd>click the #Load# button</dd><dd>to delete an imported file select it and click the #Delete# button (after activating it with the checkbox)</dd><dt>Sorting</dt><dd>#left-click# a header for primary sort</dd><dd>#right-click# for secondary sort</dd><dd>click again to switch ascending/descending</dd><dt>Display Options</dt><dd>select one or more imported data files</dd><dd>choose if ships that cannot be encountered/bought should be displayed</dd><dd>limit the output to a specific group of items</dd><dd>limit the output to a specific nation</dd><dd>select which columns should be displayed</dd><dd>click the #Display# button</dd><dt>Comparing</dt><dd>click the row you want to add to the list</dd><dd>click again to remove it</dd><dd>click the #Compare# button to see the list</dd><dd>click the #Save# button to save this comparison for future use</dd><dd>when pasting this URL you will be asked if you want to keep the sorting (like the ships were added)<br/>&nbsp;&nbsp;&nbsp;&nbsp;or if the list should be sorted alphabetically (via ship names across all files!)</dd></dl>\', TITLE, \'HELP\', OPACITY, 100, CLICKSTICKY, true, CLOSEBTN, true);" onmouseout="UnTip();">Help</abbr> ');
	
	echo ('# <abbr onmouseover="Tip(\'The ship data ingame can differ from these default values! More specifically:<dl><dt>Skills</dt><dd>I am not sure about this, but your skills (and your officers) might change the specs shown in the ships info panel</dd><dt>Upgrades</dt><dd>These really expensive upgrades have a direct impact on the ships performance and specs!</dd><dd>Especially <b>Reinforced Hull</b>, as this lets you buy bigger sized cannons!<br/>&nbsp;&nbsp;&nbsp;&nbsp;<i>-> a normal Frigate can accommodate 18 pounders; after this upgrade it fits 24 pounders!</i></dd><dt>Unique Ships</dt><dd>To get a unique ship, find <b>Hendrick Vanderdecken</b> in a <u>well known place</u> by getting a <u>well known object</u><br/>&nbsp;&nbsp;&nbsp;&nbsp;from a <u>well known character</u> in <u>another well known place</u>.</dd><dt>Nation Specific</dt><dd>Each nation has its own pros and cons:</dd></dl>\', TITLE, \'Click to make sticky!\', OPACITY, 100, CLICKSTICKY, true, CLOSEBTN, true);" onmouseout="UnTip();">Differences in ingame data</abbr> ');
	
	if (sizeof ($DataFiles) == 0)
		echo ('<div id="loadfile" class="textshow">');
	else
	{
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the load-file-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'loadfile\');">Show/Hide Load-Form</abbr> ');
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the display-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'display\');">Show/Hide Display-Form</abbr>');
		echo ('<div id="loadfile" class="texthide">');
	}
	echo ('<form name="LoadFile" action="index.php" method="POST" enctype="multipart/form-data">');
		echo ('<p class="load">Please select the item-file <span class="lowlight">(initItems.c)</span> and the names-file <span class="lowlight">(ItemsDescribe.txt)</span>, as well as a description:<br/>');
		// ships_init.c
		echo ('<input type="file" class="fileupload" name="ItemData" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the ships-file from the filesystem! <i>(initItems.c)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		// common.ini
		echo ('<input type="file" class="fileupload" name="ItemNames" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the names-file from the filesystem! <i>(ItemsDescribe.txt)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('<input type="text" class="filename" name="FileDesc" size="30" maxlength="30" onmouseover="Tip(\'Enter a description/headline for this data! <i>(eg. HorizonMod)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');	
		echo ('<input type="button" class="load" Value=" Load " onclick="LoadFileCheck();" onmouseover="Tip(\'Load the selected ships-file.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</p>');
	echo ('</form>');
	echo ('</div>');

	if (sizeof ($DataFiles) == 0)
	{
		echo ('<div class="nodata">no data yet</div>');
		exit ();
	}
	
	// Reset activated?
	if (isset ($_POST["ResetAll"]) && $_POST["ResetAll"] == "true")
		unset ($_POST);

	// Check POST for sort settings
	if (isset ($_POST["SortValue1"]) && $_POST["SortValue1"] != "")
	{
		if ($_POST["SortValue1"][0] == "-")
			$Sort1Type = "Desc";
		else
			$Sort1Type = "Asc";
		$Sort1 = substr ($_POST["SortValue1"], 1);
	}
	else
	{
		$Sort1 = "Name";
		$_POST["SortValue1"] = "+Name";
		$Sort1Type = "Asc";
	}
	
	if (isset ($_POST["SortValue2"]) && $_POST["SortValue2"] != "")
	{
		if ($_POST["SortValue2"][0] == "-")
			$Sort2Type = "Desc";
		else
			$Sort2Type = "Asc";
		$Sort2 = substr ($_POST["SortValue2"], 1);
	}
	else
	{
		$Sort2 = "";
		$_POST["SortValue2"] = "";
		$Sort2Type = "";
	}
	
	// Check POST for files to display
	if (!isset ($_POST["Objects"]) || $_POST["Objects"] == "")
		$_POST["Objects"][0] = $DataFiles[0];

	// Check POST for class filter
	if (!isset ($_POST["ShowClass"]) || $_POST["ShowClass"] == "")
		$ShowClass = 0;
	else
		$ShowClass = $_POST["ShowClass"];
	
	// Check POST for columns to display
	if (isset ($_POST["DisplayColumns"]))
		$ColumnsToDisplay = $_POST["DisplayColumns"];
	
	echo ('<div id="display" class="textshow">');
		// Display-Form
		echo ('<form name="SelectObjects" action="index.php" method="POST">');
		echo ('<input type="hidden" name="SelectObjectsChoice" size="30" maxlength="30" value="">');
		echo ('<input type="hidden" name="SortValue1" size="30" maxlength="30" value="'.$_POST["SortValue1"].'">');
		echo ('<input type="hidden" name="SortValue2" size="30" maxlength="30" value="'.$_POST["SortValue2"].'">');
		echo ('<table class="display" border="0">');
		echo ('<thead><tr><th onmouseover="Tip(\'Select the file(s) that should be displayed!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Files</th><th onmouseover="Tip(\'Select the filter(s) that should be applied!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Filter</th><th id="colspanheader" onmouseover="Tip(\'Select the column(s) that should be shown!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Columns</th><th>&nbsp;</th></tr></thead><tbody><tr>');
		echo ('<td class="one">');	// Files
			echo ('<select class="objects" id="Objects" name="Objects[]" size="5" multiple="multiple" onmouseover="Tip(\'<ul type=disc><li>Select single entries with >STRG<...</li><li>... multiple with >SHIFT<...</li><li>... and all entries wih >STRG + A<</li></ul>\', TITLE, \'Info\');" onmouseout="UnTip();">');

			foreach ($DataFiles as $DataFileName)
			{
				if (in_array ($DataFileName, $_POST["Objects"]))
					echo ('<option selected>'.$DataFileName.'</option>');
				else
					echo ('<option>'.$DataFileName.'</option>');
			}
			echo ('</select>');
		echo ('</td>');

		echo ('<td class="two">');		// Filter
			echo ('Group: <select name="ShowClass" class="dropdown" onchange="SelectFilters(this.value);" onmouseover="Tip(\'Select the class the list should be limited to.\', TITLE, \'Info\');" onmouseout="UnTip();">');
				for ($i=0; $i<sizeof ($Classes); $i++)
				{
					echo ('<option value="'.$i.'"');
					if ($ShowClass == $i)
						echo (' selected');
					echo ('>'.$Classes[$i].'</option>');
				}
			echo ('</select><br/>');
		echo ('</td>');
		echo ('<td class="three">');		// Columns
			$i = 0;
			$Modulo = 5;
			$NumCols = 1;
			
			foreach ($Include as $Column => $ColumnName)
			{
				if (stristr ($Column, "period") != false)
					break;
				
				echo ($ColumnName.': <input type="checkbox" class="checkbox" name="DisplayColumns[]"');
				if ($ColumnsToDisplay === false || in_array ($Column, $ColumnsToDisplay))
					echo ('checked ');
				echo ('value="'.$Column.'" onmouseover="Tip(\'Displays this column if enabled!\');" onmouseout="UnTip();" /><br/>');
				
				$i++;
				
				if (($i%$Modulo) == 0)
				{
					echo ('</td><td class="three">');
					$NumCols++;
				}
			}

			// Update header colspan			
			echo ('<script>document.getElementById("colspanheader").colSpan = "'.$NumCols.'";</script>');
			// Needed to be able to reset the form via JS
			echo ('<input type="hidden" name="ResetAll" value="false">');
		echo ('</td>');
		echo ('<td class="four">');
			echo ('<input type="button" class="button" value="  Display  " onclick="DisplayObject();" onmouseover="Tip(\'Display the selected entries.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="buttondis" name="DelObj" disabled value="   Delete   " onclick="DeleteObject();" onmouseover="Tip(\'Delete the <u>selected</u> entries.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
			echo ('<input type="checkbox" class="checkbox" name="DelObjCheck" value="delete" onclick="DeleteObjectCheck();" onmouseover="Tip(\'Enable/Disable the <i>Delete</i>-Button.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="button" name="ResetDisplay" value="   Reset   " onclick="DelPost();" onmouseover="Tip(\'Clear the display options.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</td>');
		echo ('</tr></tbody></table></form>');
	echo ('</div>');


// Show Content
	foreach ($_POST["Objects"] as $Selected)
	{
		$Data = LoadData ($Selected);

		if ($Sort2 == "")
			$Data = SortDataBy ($Data, $_POST["SortValue1"]);
		else
			$Data = SortDataBy ($Data, $_POST["SortValue1"], $_POST["SortValue2"]);
		
		echo ('<h2>'.$Selected.'</h2>');
		
		echo ('<table class="ships">');

		// Headers
		echo ('<thead><tr id="Header" class="header">');
			if ($Sort1 == "Name")
				echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="Name" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else if ($Sort2 == "Name")
				echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="Name" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else
				echo ('<td class="clickable" name="Name" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			
			foreach ($Include as $Type => $TypeName)
			{
				if ($ColumnsToDisplay === false || in_array ($Type, $ColumnsToDisplay))
				{
					if ($Type == $Sort1)
						echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="'.$Type.'" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
					else if ($Type == $Sort2)
						echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="'.$Type.'" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
					else
						echo ('<td class="clickable" name="'.$Type.'" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
				}
			}
		echo ('</thead></tr><tbody>');
		
		// Data
		foreach ($Data as $ItemName => $ItemData)
		{
			if ($ShowClass == 0 || $ShowClass == array_search ($ItemData['groupID'], $Classes))
			{
				// Daten des Schiffes gleich ausgeben wie "Header"
				$ItemData = array_merge (array_fill_keys (array_keys ($Include), ''), $ItemData);
				
				echo ('<tr class="highlight" onclick="SwitchCompare (this, \''.$Selected.'\')"><th>'.$ItemName.'</th>');
				foreach ($ItemData as $Key => $Value)
				{
					if ($ColumnsToDisplay === false || in_array ($Key, $ColumnsToDisplay))
					{
						if ($Value == '')
							echo ('<td style="color:gray;">-</td>');
						else
							echo ('<td onmouseover="Tip(\''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.mb_convert_encoding  ($Value, "UTF-8", "ASCII").'</td>');
					}
				}
				echo ('</tr>');
			}
		}
		echo ('</tbody></table>');
	}

	
// Compare TABLE (empty)
	echo ('<div id="DivCompare">');
		echo ('<h2>Comparison</h2>');
		
		echo ('<table class="ships" id="TableCompare">');
		
		// Show Saved Comparison
		if (!empty($_GET))
		{
			ShowSavedCompare ($_GET);
		}
			
		echo ('</table><div>');
		echo ('<span onclick="SaveCompare();" onmouseover="Tip(\'Click to save the comparison (by URL)!\');" onmouseout="UnTip();">> save <</span>');		
		echo ('<span onclick="HideCompare();" onmouseover="Tip(\'Click to hide comparison!\');" onmouseout="UnTip();">> close <</span>');		
	echo ('</div></div>');
	?>
</body>
</html>
